
#include <stdio.h>

void main(int argc, char *argv[]) {
  FILE *fpin; 
  FILE *fpout;

  unsigned char b;
  int i;

  if (argc != 3) {
    fprintf(stderr, "SYNTAX ERROR !\nSyntax : bin2asm inputfile outputfile\n");
    _exit(0);
  }

  fpin = fopen(argv[1], "rb");
  if (fpin == NULL) {
    fprintf(stderr, "Error opening input file %s\n", argv[1]);
    _exit(10);
  }

  fpout = fopen(argv[2], "wt");
  if (fpout == NULL) {
    fprintf(stderr, "Error opening outfile %s\n", argv[2]);
    _exit(20);
  }

  i = 0;
  fprintf(fpout, ".global MODULEFILEPTR\n");
  fprintf(fpout, ".global MODULEFILEENDPTR\n");
  fprintf(fpout, ".data\n.align 4\n");
  fprintf(fpout, "MODULEFILEPTR:");

  while (!feof(fpin)) {
    fread(&b, 1, 1, fpin);
    if ((i % 18) == 0) {
      fprintf(fpout, "\n");
      fprintf(fpout, ".byte %d", b);
    } else {
      fprintf(fpout, ",%d", b);
    }
    i++;
  }

  fprintf(fpout, "\nMODULEFILEENDPTR:\n.align 4\n");

  fclose(fpin);
  fclose(fpout);
}
