
; entry point code for N64

; macro to zero a section for initialising bss areas
; assumes the section is a multiple of 4 bytes long
; the parameter (sec) must have been declared in a section statement


zerosect	macro	sec
	local	l1,l2

	la	t0,sect(\sec)
	la	t1,sectend(\sec)
	beq	t0,t1,l2	; in case section is empty
	nop
l1:
	addiu	t0,t0,4
	sltu	at,t0,t1
	bne	at,zero,l1
	sw	zero,-4(t0)
l2:
	endm

; 4k header area for front of cartridge

	section	.header
	dcb	4096,0


; declaration of sections we're going to initialise to 0

	section	.bss

; start up code

	xref	boot

	section	.start

	la	sp,$80400000-16	; initialise stack pointer

	zerosect .bss	; clear out .bss section
	li	t0, $BFC007FC
	li	t1, $8
	sw	t1, 0(t0)
	
        li  t0,$a4400000
        li  t1,$3303
        sw  t1,0(t0)
        la  t1,$0     
        sw  t1,4(t0)
        li  t1,$140
        sw  t1,8(t0)
        li  t1,$2
        sw  t1,12(t0)
        li  t1,$0 
        sw  t1,16(t0)
        li  t1,$3e52239
        sw  t1,20(t0)
        li  t1,$0000020d
        sw  t1,24(t0)
        li  t1,$00000c15
        sw  t1,28(t0)
        li  t1,$0c150c15
        sw  t1,32(t0)
        li  t1,$006c02ec
        sw  t1,36(t0)
        li  t1,$002501ff
        sw  t1,40(t0)
        li  t1,$000e0204
        sw  t1,44(t0)
        li  t1,$200
        sw  t1,48(t0)
        li  t1,$400
        sw  t1,52(t0)

	; Setting Screen Address
	li	t0, $A4400004
	li	t1, $A0300000
	sw	t1, 0(t0)
	
	li	t0, $A0200000
	li	t1, 320*240
	li	t2, $00000000
ClearLoop:	
	sw	t2, 0(t0)
	add	t0, 4
	sub	t1, 1
	bne	t1, zero, ClearLoop
	nop		


	jal	boot	; go execute users program
	nop

	break	$402	; just in case it returns

