/*

Name:
DRV_N64.C

Description:
Mikmod driver for output to a file called MUSIC.RAW

MS-DOS Programmers:
 !! DO NOT CALL MD_UPDATE FROM A INTERRUPT IF YOU USE THIS DRIVER !!

Portability:

MSDOS:  BC(y)   Watcom(y)   DJGPP(y)
Win95:  BC(y)
Linux:  y

(y) - yes
(n) - no (not possible or not useful)
(?) - may be possible, but not tested

*/

#include "mikmod.h"

#define RAWBUFFERSIZE 40000 // was 40000
#define DMABUFFERWAIT 20 // was 20

static SBYTE RAW_DMABUF1[RAWBUFFERSIZE];
static SBYTE RAW_DMABUF2[RAWBUFFERSIZE];

int activebuf = 0;

static int rawout;

static SBYTE RAW_DMABUF[RAWBUFFERSIZE];


static BOOL N64_IsThere(void)
{
    return 1;
}


static BOOL N64_Init(void)
{

    md_mode |= DMODE_SOFT_MUSIC | DMODE_SOFT_SNDFX;
    memset(RAW_DMABUF1 + 0x20000000, 0, RAWBUFFERSIZE);

    *((ULONG*)0xa4500000)=RAW_DMABUF1 + 0x20000000;
    *((ULONG*)0xa4500004)=1;
    *((ULONG*)0xa4500010)=0x00000465;
    *((ULONG*)0xa4500014)=0x0000000f;
    *((ULONG*)0xa4500008)=1;

    if(VC_Init()) return 1;

    return 0;
}


static void N64_Exit(void)
{
    VC_Exit();
}

void show_buf1() {
  int it;

  for (it = 0; it < 256; it++) {
    putpixel(it+30, (*((SWORD *)(RAW_DMABUF1+it*4)) >> 10) + 50, 32, 0, 32);
    putpixel(it+30, (*((SWORD *)(RAW_DMABUF1+it*4+2)) >> 10) + 150, 32, 32, 0);
  }
}

void show_buf2() {
  int it;

  for (it = 0; it < 256; it++) {
    putpixel(it+30, (*((SWORD *)(RAW_DMABUF2+it*4)) >> 10) + 50, 32, 0, 32);
    putpixel(it+30, (*((SWORD *)(RAW_DMABUF2+it*4+2)) >> 10) + 150, 32, 32, 0);
  }
}

static void N64_Update(void)
{
  ULONG it;
     
  if (activebuf == 0) {
    if ((*((ULONG*)0xa450000C) & 0x80000000) == 0) { // is FIFO clear for swap ?
      VC_WriteBytes(RAW_DMABUF1 + 0x20000000 ,RAWBUFFERSIZE);

      *((ULONG*)0xa450000C)= 0x00000000;
      *((ULONG*)0xa4500000)=RAW_DMABUF1 + 0x20000000;
      *((ULONG*)0xa4500004)=RAWBUFFERSIZE;
      activebuf = 1;
    }
  } else {
    if ((*((ULONG*)0xa450000C) & 0x80000000) == 0) { // is FIFO clear for swap ? 

      VC_WriteBytes(RAW_DMABUF2+ 0x20000000 ,RAWBUFFERSIZE);

      *((ULONG*)0xa450000C)= 0x00000000;
      *((ULONG*)0xa4500000)=RAW_DMABUF2 + 0x20000000 ;
      *((ULONG*)0xa4500004)=RAWBUFFERSIZE;
      activebuf = 0;
    }
  }
}


static BOOL N64_Reset(void)
{
    return 0;
}


MDRIVER drv_n64 =
{   NULL,
    "N64 blabla",
    "N64 driver list",
    0,255,
    N64_IsThere,
    VC_SampleLoad,
    VC_SampleUnload,
    VC_SampleSpace,
    VC_SampleLength,
    N64_Init,
    N64_Exit,
    N64_Reset,
    VC_SetNumVoices,
    VC_PlayStart,
    VC_PlayStop,
    N64_Update,
    VC_VoiceSetVolume,
    VC_VoiceSetFrequency,
    VC_VoiceSetPanning,
    VC_VoicePlay,
    VC_VoiceStop,
    VC_VoiceStopped,
    VC_VoiceReleaseSustain,
    VC_VoiceGetPosition,
    VC_VoiceRealVolume
};





